diff --git a/.ci/linux-build.sh b/.ci/linux-build.sh
index 5225dc71c4..ab0994388a 100755
--- a/.ci/linux-build.sh
+++ b/.ci/linux-build.sh
@@ -9,25 +9,6 @@ fi
 # Builds are run as root in containers, no need for sudo
 [ "$(id -u)" != '0' ] || alias sudo=
 
-on_error() {
-    if [ $? = 0 ]; then
-        exit
-    fi
-    FILES_TO_PRINT="build/meson-logs/testlog.txt"
-    FILES_TO_PRINT="$FILES_TO_PRINT build/.ninja_log"
-    FILES_TO_PRINT="$FILES_TO_PRINT build/meson-logs/meson-log.txt"
-    FILES_TO_PRINT="$FILES_TO_PRINT build/gdb.log"
-
-    for pr_file in $FILES_TO_PRINT; do
-        if [ -e "$pr_file" ]; then
-            cat "$pr_file"
-        fi
-    done
-}
-# We capture the error logs as artifacts in Github Actions, no need to dump
-# them via a EXIT handler.
-[ -n "$GITHUB_WORKFLOW" ] || trap on_error EXIT
-
 install_libabigail() {
     version=$1
     instdir=$2
diff --git a/.travis.yml b/.travis.yml
deleted file mode 100644
index 0936788dc7..0000000000
--- a/.travis.yml
+++ /dev/null
@@ -1,172 +0,0 @@
-# default values for all jobs
-language: c
-cache:
-  ccache: true
-  directories:
-    - libabigail
-    - reference
-
-dist: bionic
-
-os: linux
-
-addons:
-  apt:
-    update: true
-    packages: &required_packages
-      - [libnuma-dev, python3-setuptools, python3-wheel, python3-pip, python3-pyelftools, ninja-build]
-      - [libbsd-dev, libpcap-dev, libibverbs-dev, libcrypto++-dev, libfdt-dev, libjansson-dev]
-      - [libarchive-dev]
-
-_aarch64_packages: &aarch64_packages
-  - *required_packages
-  - [gcc-aarch64-linux-gnu, libc6-dev-arm64-cross, pkg-config-aarch64-linux-gnu]
-
-_aarch64_clang_packages: &aarch64_clang_packages
-  - *required_packages
-  - [libgcc-7-dev-arm64-cross, libatomic1-arm64-cross, libc6-dev-arm64-cross, pkg-config-aarch64-linux-gnu]
-
-_libabigail_build_packages: &libabigail_build_packages
-  - [autoconf, automake, libtool, pkg-config, libxml2-dev, libdw-dev]
-
-_build_32b_packages: &build_32b_packages
-  - *required_packages
-  - [gcc-multilib]
-
-_doc_packages: &doc_packages
-  - [doxygen, graphviz, python3-sphinx]
-
-before_install: ./.ci/${TRAVIS_OS_NAME}-setup.sh
-script: ./.ci/${TRAVIS_OS_NAME}-build.sh
-
-env:
-  global:
-    - LIBABIGAIL_VERSION=libabigail-2.1
-    - REF_GIT_REPO=https://dpdk.org/git/dpdk-stable
-    - REF_GIT_TAG=v22.11.1
-
-jobs:
-  include:
-  # x86_64 gcc jobs
-  - env: DEF_LIB="static"
-    arch: amd64
-    compiler: gcc
-  - env: DEF_LIB="shared" RUN_TESTS=true
-    arch: amd64
-    compiler: gcc
-  - env: DEF_LIB="shared" BUILD_DOCS=true
-    arch: amd64
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *required_packages
-          - *doc_packages
-  - env: DEF_LIB="shared" ABI_CHECKS=true
-    arch: amd64
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *required_packages
-          - *libabigail_build_packages
-  # x86_64 clang jobs
-  - env: DEF_LIB="static"
-    arch: amd64
-    compiler: clang
-  - env: DEF_LIB="shared" RUN_TESTS=true
-    arch: amd64
-    compiler: clang
-  - env: DEF_LIB="shared" BUILD_DOCS=true
-    arch: amd64
-    compiler: clang
-    addons:
-      apt:
-        packages:
-          - *required_packages
-          - *doc_packages
-  # x86_64 cross-compiling 32-bits jobs
-  - env: DEF_LIB="static" BUILD_32BIT=true
-    arch: amd64
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *build_32b_packages
-  # x86_64 cross-compiling aarch64 jobs
-  - env: DEF_LIB="static" AARCH64=true
-    arch: amd64
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *aarch64_packages
-  - env: DEF_LIB="shared" AARCH64=true
-    arch: amd64
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *aarch64_packages
-  - env: DEF_LIB="static" AARCH64=true
-    arch: amd64
-    compiler: clang
-    addons:
-      apt:
-        packages:
-          - *aarch64_clang_packages
-  - env: DEF_LIB="shared" AARCH64=true
-    arch: amd64
-    compiler: clang
-    addons:
-      apt:
-        packages:
-          - *aarch64_clang_packages
-  # aarch64 gcc jobs
-  - env: DEF_LIB="static"
-    dist: focal
-    arch: arm64-graviton2
-    virt: vm
-    group: edge
-    compiler: gcc
-  - env: DEF_LIB="shared" RUN_TESTS=true
-    dist: focal
-    arch: arm64-graviton2
-    virt: vm
-    group: edge
-    compiler: gcc
-  - env: DEF_LIB="shared" BUILD_DOCS=true
-    dist: focal
-    arch: arm64-graviton2
-    virt: vm
-    group: edge
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *required_packages
-          - *doc_packages
-  - env: DEF_LIB="shared" ABI_CHECKS=true
-    dist: focal
-    arch: arm64-graviton2
-    virt: vm
-    group: edge
-    compiler: gcc
-    addons:
-      apt:
-        packages:
-          - *required_packages
-          - *libabigail_build_packages
-  # aarch64 clang jobs
-  - env: DEF_LIB="static"
-    dist: focal
-    arch: arm64-graviton2
-    virt: vm
-    group: edge
-    compiler: clang
-  - env: DEF_LIB="shared" RUN_TESTS=true
-    dist: focal
-    arch: arm64-graviton2
-    virt: vm
-    group: edge
-    compiler: clang
diff --git a/MAINTAINERS b/MAINTAINERS
index 3dc3f5b348..9a0f416d2e 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -131,7 +131,6 @@ F: devtools/check-meson.py
 Public CI
 M: Aaron Conole <aconole@redhat.com>
 M: Michael Santana <maicolgabriel@hotmail.com>
-F: .travis.yml
 F: .github/workflows/build.yml
 F: .ci/
 
diff --git a/devtools/check-spdx-tag.sh b/devtools/check-spdx-tag.sh
index 89b2d643a4..7624778a8c 100755
--- a/devtools/check-spdx-tag.sh
+++ b/devtools/check-spdx-tag.sh
@@ -20,7 +20,7 @@ check_spdx() {
 	echo "--------------------------"
     fi
     git grep -L SPDX-License-Identifier -- \
-	':^.git*' ':^.mailmap' ':^.ci/*' ':^.travis.yml' \
+	':^.git*' ':^.mailmap' ':^.ci/*' \
 	':^README' ':^MAINTAINERS' ':^VERSION' ':^ABI_VERSION' \
 	':^*/Kbuild' ':^*/README' \
 	':^license/' ':^config/' ':^buildtools/' ':^*/poetry.lock' \
diff --git a/doc/guides/contributing/patches.rst b/doc/guides/contributing/patches.rst
index b3eaf7df03..e286d9e6d5 100644
--- a/doc/guides/contributing/patches.rst
+++ b/doc/guides/contributing/patches.rst
@@ -35,10 +35,6 @@ It is also worth registering for the DPDK `Patchwork <https://patches.dpdk.org/p
 If you are using the GitHub service, pushing to a branch will trigger GitHub
 Actions to automatically build your changes and run unit tests and ABI checks.
 
-Additionally, a Travis configuration is available in DPDK but Travis free usage
-is limited to a few builds.
-You can link your repository to the ``travis-ci.com`` build service.
-
 The development process requires some familiarity with the ``git`` version control system.
 Refer to the `Pro Git Book <http://www.git-scm.com/book/>`_ for further information.
 